import{S as no,i as ro,s as so,e as n,k as d,w as Ke,t as o,M as lo,c as r,d as a,m as p,a as s,x as Qe,h as i,b as h,G as e,g as c,y as Ve,L as ho,q as Xe,o as Ye,B as Ze,v as co}from"../../chunks/vendor-hf-doc-builder.js";import{I as et}from"../../chunks/IconCopyLink-hf-doc-builder.js";function fo(ba){let _,Te,E,P,oe,D,tt,ie,at,Pe,v,ot,ne,it,nt,re,rt,st,$e,g,lt,M,ht,ct,se,ft,dt,z,pt,ut,xe,A,$,le,N,gt,he,mt,Re,f,vt,ce,yt,bt,F,wt,_t,fe,Et,At,de,Ht,kt,pe,Tt,Pt,ue,$t,xt,ge,Rt,It,me,St,Ot,Ie,U,Ct,Se,x,Dt,B,Nt,Gt,Oe,H,R,ve,G,Lt,ye,qt,Ce,y,Wt,J,Mt,zt,j,Ft,Ut,De,b,Bt,be,Jt,jt,K,Kt,Qt,Ne,k,I,we,L,Vt,_e,Xt,Ge,m,Yt,Ee,Zt,ea,Ae,ta,aa,Q,oa,ia,Le,S,q,na,V,ra,sa,la,T,ha,He,ca,fa,ke,da,pa,qe,w,ua,X,ga,ma,W,va,ya,We;return D=new et({}),N=new et({}),G=new et({}),L=new et({}),{c(){_=n("meta"),Te=d(),E=n("h1"),P=n("a"),oe=n("span"),Ke(D.$$.fragment),tt=d(),ie=n("span"),at=o("Git vs HTTP paradigm"),Pe=d(),v=n("p"),ot=o("The "),ne=n("code"),it=o("huggingface_hub"),nt=o(` library is a library for interacting with the Hugging Face Hub, which is a
collections of git-based repositories (models, datasets or Spaces). There are two main
ways to access the Hub using `),re=n("code"),rt=o("huggingface_hub"),st=o("."),$e=d(),g=n("p"),lt=o("The first approach, the so-called \u201Cgit-based\u201D approach, is led by the "),M=n("a"),ht=o("Repository"),ct=o(` class.
This method uses a wrapper around the `),se=n("code"),ft=o("git"),dt=o(` command with additional functions specifically
designed to interact with the Hub. The second option, called the \u201CHTTP-based\u201D approach,
involves making HTTP requests using the `),z=n("a"),pt=o("HfApi"),ut=o(` client. Let\u2019s examine the pros and cons
of each approach.`),xe=d(),A=n("h2"),$=n("a"),le=n("span"),Ke(N.$$.fragment),gt=d(),he=n("span"),mt=o("Repository: the historical git-based approach"),Re=d(),f=n("p"),vt=o("At first, "),ce=n("code"),yt=o("huggingface_hub"),bt=o(" was mostly built around the "),F=n("a"),wt=o("Repository"),_t=o(` class. It provides
Python wrappers for common `),fe=n("code"),Et=o("git"),At=o(" commands such as "),de=n("code"),Ht=o('"git add"'),kt=o(", "),pe=n("code"),Tt=o('"git commit"'),Pt=o(", "),ue=n("code"),$t=o('"git push"'),xt=o(`,
`),ge=n("code"),Rt=o('"git tag"'),It=o(", "),me=n("code"),St=o('"git checkout"'),Ot=o(", etc."),Ie=d(),U=n("p"),Ct=o(`The library also helps with setting credentials and tracking large files, which are often
used in machine learning repositories. Additionally, the library allows you to execute its
methods in the background, making it useful for uploading data during training.`),Se=d(),x=n("p"),Dt=o("The main advantage of using a "),B=n("a"),Nt=o("Repository"),Gt=o(` is that it allows you to maintain a local
copy of the entire repository on your machine. This can also be a disadvantage as
it requires you to constantly update and maintain this local copy. This is similar to
traditional software development where each developer maintains their own local copy and
pushes changes when working on a feature. However, in the context of machine learning,
this may not always be necessary as users may only need to download weights for inference
or convert weights from one format to another without the need to clone the entire
repository.`),Oe=d(),H=n("h2"),R=n("a"),ve=n("span"),Ke(G.$$.fragment),Lt=d(),ye=n("span"),qt=o("HfApi: a flexible and convenient HTTP client"),Ce=d(),y=n("p"),Wt=o("The "),J=n("a"),Mt=o("HfApi"),zt=o(` class was developed to provide an alternative to local git repositories, which
can be cumbersome to maintain, especially when dealing with large models or datasets. The
`),j=n("a"),Ft=o("HfApi"),Ut=o(` class offers the same functionality as git-based approaches, such as downloading
and pushing files and creating branches and tags, but without the need for a local folder
that needs to be kept in sync.`),De=d(),b=n("p"),Bt=o("In addition to the functionalities already provided by "),be=n("code"),Jt=o("git"),jt=o(", the "),K=n("a"),Kt=o("HfApi"),Qt=o(` class offers
additional features, such as the ability to manage repos, download files using caching for
efficient reuse, search the Hub for repos and metadata, access community features such as
discussions, PRs, and comments, and configure Spaces hardware and secrets.`),Ne=d(),k=n("h2"),I=n("a"),we=n("span"),Ke(L.$$.fragment),Vt=d(),_e=n("span"),Xt=o("What should I use ? And when ?"),Ge=d(),m=n("p"),Yt=o("Overall, the "),Ee=n("strong"),Zt=o("HTTP-based approach is the recommended way to use"),ea=d(),Ae=n("code"),ta=o("huggingface_hub"),aa=o(`
in most cases. However, there are a few situations where maintaining a local git clone
(using `),Q=n("a"),oa=o("Repository"),ia=o(") may be more beneficial:"),Le=d(),S=n("ul"),q=n("li"),na=o(`If you are training a model on your machine, it may be more efficient to use a traditional
git-based workflow, pushing regular updates. `),V=n("a"),ra=o("Repository"),sa=o(` is optimized for this type of
situation with its ability to work in the background.`),la=d(),T=n("li"),ha=o("If you need to manually edit large files, "),He=n("code"),ca=o("git"),fa=o(` is the best option as it only sends the
diff to the server. With the `),ke=n("code"),da=o("HfAPI"),pa=o(` client, the entire file is uploaded with each edit.
Do keep in mind that most large files are binary so do not benefit from git diffs anyway.`),qe=d(),w=n("p"),ua=o("Not all git commands are available through "),X=n("a"),ga=o("HfApi"),ma=o(`. Some may never be implemented, but
we are always trying to improve and close the gap. If you don\u2019t see your use case covered,
please open `),W=n("a"),va=o("an issue on Github"),ya=o(`! We
welcome feedback to help build the \u{1F917} ecosystem with and for our users.`),this.h()},l(t){const l=lo('[data-svelte="svelte-1phssyn"]',document.head);_=r(l,"META",{name:!0,content:!0}),l.forEach(a),Te=p(t),E=r(t,"H1",{class:!0});var Me=s(E);P=r(Me,"A",{id:!0,class:!0,href:!0});var wa=s(P);oe=r(wa,"SPAN",{});var _a=s(oe);Qe(D.$$.fragment,_a),_a.forEach(a),wa.forEach(a),tt=p(Me),ie=r(Me,"SPAN",{});var Ea=s(ie);at=i(Ea,"Git vs HTTP paradigm"),Ea.forEach(a),Me.forEach(a),Pe=p(t),v=r(t,"P",{});var Y=s(v);ot=i(Y,"The "),ne=r(Y,"CODE",{});var Aa=s(ne);it=i(Aa,"huggingface_hub"),Aa.forEach(a),nt=i(Y,` library is a library for interacting with the Hugging Face Hub, which is a
collections of git-based repositories (models, datasets or Spaces). There are two main
ways to access the Hub using `),re=r(Y,"CODE",{});var Ha=s(re);rt=i(Ha,"huggingface_hub"),Ha.forEach(a),st=i(Y,"."),Y.forEach(a),$e=p(t),g=r(t,"P",{});var O=s(g);lt=i(O,"The first approach, the so-called \u201Cgit-based\u201D approach, is led by the "),M=r(O,"A",{href:!0});var ka=s(M);ht=i(ka,"Repository"),ka.forEach(a),ct=i(O,` class.
This method uses a wrapper around the `),se=r(O,"CODE",{});var Ta=s(se);ft=i(Ta,"git"),Ta.forEach(a),dt=i(O,` command with additional functions specifically
designed to interact with the Hub. The second option, called the \u201CHTTP-based\u201D approach,
involves making HTTP requests using the `),z=r(O,"A",{href:!0});var Pa=s(z);pt=i(Pa,"HfApi"),Pa.forEach(a),ut=i(O,` client. Let\u2019s examine the pros and cons
of each approach.`),O.forEach(a),xe=p(t),A=r(t,"H2",{class:!0});var ze=s(A);$=r(ze,"A",{id:!0,class:!0,href:!0});var $a=s($);le=r($a,"SPAN",{});var xa=s(le);Qe(N.$$.fragment,xa),xa.forEach(a),$a.forEach(a),gt=p(ze),he=r(ze,"SPAN",{});var Ra=s(he);mt=i(Ra,"Repository: the historical git-based approach"),Ra.forEach(a),ze.forEach(a),Re=p(t),f=r(t,"P",{});var u=s(f);vt=i(u,"At first, "),ce=r(u,"CODE",{});var Ia=s(ce);yt=i(Ia,"huggingface_hub"),Ia.forEach(a),bt=i(u," was mostly built around the "),F=r(u,"A",{href:!0});var Sa=s(F);wt=i(Sa,"Repository"),Sa.forEach(a),_t=i(u,` class. It provides
Python wrappers for common `),fe=r(u,"CODE",{});var Oa=s(fe);Et=i(Oa,"git"),Oa.forEach(a),At=i(u," commands such as "),de=r(u,"CODE",{});var Ca=s(de);Ht=i(Ca,'"git add"'),Ca.forEach(a),kt=i(u,", "),pe=r(u,"CODE",{});var Da=s(pe);Tt=i(Da,'"git commit"'),Da.forEach(a),Pt=i(u,", "),ue=r(u,"CODE",{});var Na=s(ue);$t=i(Na,'"git push"'),Na.forEach(a),xt=i(u,`,
`),ge=r(u,"CODE",{});var Ga=s(ge);Rt=i(Ga,'"git tag"'),Ga.forEach(a),It=i(u,", "),me=r(u,"CODE",{});var La=s(me);St=i(La,'"git checkout"'),La.forEach(a),Ot=i(u,", etc."),u.forEach(a),Ie=p(t),U=r(t,"P",{});var qa=s(U);Ct=i(qa,`The library also helps with setting credentials and tracking large files, which are often
used in machine learning repositories. Additionally, the library allows you to execute its
methods in the background, making it useful for uploading data during training.`),qa.forEach(a),Se=p(t),x=r(t,"P",{});var Fe=s(x);Dt=i(Fe,"The main advantage of using a "),B=r(Fe,"A",{href:!0});var Wa=s(B);Nt=i(Wa,"Repository"),Wa.forEach(a),Gt=i(Fe,` is that it allows you to maintain a local
copy of the entire repository on your machine. This can also be a disadvantage as
it requires you to constantly update and maintain this local copy. This is similar to
traditional software development where each developer maintains their own local copy and
pushes changes when working on a feature. However, in the context of machine learning,
this may not always be necessary as users may only need to download weights for inference
or convert weights from one format to another without the need to clone the entire
repository.`),Fe.forEach(a),Oe=p(t),H=r(t,"H2",{class:!0});var Ue=s(H);R=r(Ue,"A",{id:!0,class:!0,href:!0});var Ma=s(R);ve=r(Ma,"SPAN",{});var za=s(ve);Qe(G.$$.fragment,za),za.forEach(a),Ma.forEach(a),Lt=p(Ue),ye=r(Ue,"SPAN",{});var Fa=s(ye);qt=i(Fa,"HfApi: a flexible and convenient HTTP client"),Fa.forEach(a),Ue.forEach(a),Ce=p(t),y=r(t,"P",{});var Z=s(y);Wt=i(Z,"The "),J=r(Z,"A",{href:!0});var Ua=s(J);Mt=i(Ua,"HfApi"),Ua.forEach(a),zt=i(Z,` class was developed to provide an alternative to local git repositories, which
can be cumbersome to maintain, especially when dealing with large models or datasets. The
`),j=r(Z,"A",{href:!0});var Ba=s(j);Ft=i(Ba,"HfApi"),Ba.forEach(a),Ut=i(Z,` class offers the same functionality as git-based approaches, such as downloading
and pushing files and creating branches and tags, but without the need for a local folder
that needs to be kept in sync.`),Z.forEach(a),De=p(t),b=r(t,"P",{});var ee=s(b);Bt=i(ee,"In addition to the functionalities already provided by "),be=r(ee,"CODE",{});var Ja=s(be);Jt=i(Ja,"git"),Ja.forEach(a),jt=i(ee,", the "),K=r(ee,"A",{href:!0});var ja=s(K);Kt=i(ja,"HfApi"),ja.forEach(a),Qt=i(ee,` class offers
additional features, such as the ability to manage repos, download files using caching for
efficient reuse, search the Hub for repos and metadata, access community features such as
discussions, PRs, and comments, and configure Spaces hardware and secrets.`),ee.forEach(a),Ne=p(t),k=r(t,"H2",{class:!0});var Be=s(k);I=r(Be,"A",{id:!0,class:!0,href:!0});var Ka=s(I);we=r(Ka,"SPAN",{});var Qa=s(we);Qe(L.$$.fragment,Qa),Qa.forEach(a),Ka.forEach(a),Vt=p(Be),_e=r(Be,"SPAN",{});var Va=s(_e);Xt=i(Va,"What should I use ? And when ?"),Va.forEach(a),Be.forEach(a),Ge=p(t),m=r(t,"P",{});var C=s(m);Yt=i(C,"Overall, the "),Ee=r(C,"STRONG",{});var Xa=s(Ee);Zt=i(Xa,"HTTP-based approach is the recommended way to use"),Xa.forEach(a),ea=p(C),Ae=r(C,"CODE",{});var Ya=s(Ae);ta=i(Ya,"huggingface_hub"),Ya.forEach(a),aa=i(C,`
in most cases. However, there are a few situations where maintaining a local git clone
(using `),Q=r(C,"A",{href:!0});var Za=s(Q);oa=i(Za,"Repository"),Za.forEach(a),ia=i(C,") may be more beneficial:"),C.forEach(a),Le=p(t),S=r(t,"UL",{});var Je=s(S);q=r(Je,"LI",{});var je=s(q);na=i(je,`If you are training a model on your machine, it may be more efficient to use a traditional
git-based workflow, pushing regular updates. `),V=r(je,"A",{href:!0});var eo=s(V);ra=i(eo,"Repository"),eo.forEach(a),sa=i(je,` is optimized for this type of
situation with its ability to work in the background.`),je.forEach(a),la=p(Je),T=r(Je,"LI",{});var te=s(T);ha=i(te,"If you need to manually edit large files, "),He=r(te,"CODE",{});var to=s(He);ca=i(to,"git"),to.forEach(a),fa=i(te,` is the best option as it only sends the
diff to the server. With the `),ke=r(te,"CODE",{});var ao=s(ke);da=i(ao,"HfAPI"),ao.forEach(a),pa=i(te,` client, the entire file is uploaded with each edit.
Do keep in mind that most large files are binary so do not benefit from git diffs anyway.`),te.forEach(a),Je.forEach(a),qe=p(t),w=r(t,"P",{});var ae=s(w);ua=i(ae,"Not all git commands are available through "),X=r(ae,"A",{href:!0});var oo=s(X);ga=i(oo,"HfApi"),oo.forEach(a),ma=i(ae,`. Some may never be implemented, but
we are always trying to improve and close the gap. If you don\u2019t see your use case covered,
please open `),W=r(ae,"A",{href:!0,rel:!0});var io=s(W);va=i(io,"an issue on Github"),io.forEach(a),ya=i(ae,`! We
welcome feedback to help build the \u{1F917} ecosystem with and for our users.`),ae.forEach(a),this.h()},h(){h(_,"name","hf:doc:metadata"),h(_,"content",JSON.stringify(po)),h(P,"id","git-vs-http-paradigm"),h(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(P,"href","#git-vs-http-paradigm"),h(E,"class","relative group"),h(M,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/repository#huggingface_hub.Repository"),h(z,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/hf_api#huggingface_hub.HfApi"),h($,"id","repository-the-historical-gitbased-approach"),h($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h($,"href","#repository-the-historical-gitbased-approach"),h(A,"class","relative group"),h(F,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/repository#huggingface_hub.Repository"),h(B,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/repository#huggingface_hub.Repository"),h(R,"id","hfapi-a-flexible-and-convenient-http-client"),h(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(R,"href","#hfapi-a-flexible-and-convenient-http-client"),h(H,"class","relative group"),h(J,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/hf_api#huggingface_hub.HfApi"),h(j,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/hf_api#huggingface_hub.HfApi"),h(K,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/hf_api#huggingface_hub.HfApi"),h(I,"id","what-should-i-use-and-when"),h(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(I,"href","#what-should-i-use-and-when"),h(k,"class","relative group"),h(Q,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/repository#huggingface_hub.Repository"),h(V,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/repository#huggingface_hub.Repository"),h(X,"href","/docs/huggingface_hub/v0.14.0.rc1/en/package_reference/hf_api#huggingface_hub.HfApi"),h(W,"href","https://github.com/huggingface/huggingface_hub"),h(W,"rel","nofollow")},m(t,l){e(document.head,_),c(t,Te,l),c(t,E,l),e(E,P),e(P,oe),Ve(D,oe,null),e(E,tt),e(E,ie),e(ie,at),c(t,Pe,l),c(t,v,l),e(v,ot),e(v,ne),e(ne,it),e(v,nt),e(v,re),e(re,rt),e(v,st),c(t,$e,l),c(t,g,l),e(g,lt),e(g,M),e(M,ht),e(g,ct),e(g,se),e(se,ft),e(g,dt),e(g,z),e(z,pt),e(g,ut),c(t,xe,l),c(t,A,l),e(A,$),e($,le),Ve(N,le,null),e(A,gt),e(A,he),e(he,mt),c(t,Re,l),c(t,f,l),e(f,vt),e(f,ce),e(ce,yt),e(f,bt),e(f,F),e(F,wt),e(f,_t),e(f,fe),e(fe,Et),e(f,At),e(f,de),e(de,Ht),e(f,kt),e(f,pe),e(pe,Tt),e(f,Pt),e(f,ue),e(ue,$t),e(f,xt),e(f,ge),e(ge,Rt),e(f,It),e(f,me),e(me,St),e(f,Ot),c(t,Ie,l),c(t,U,l),e(U,Ct),c(t,Se,l),c(t,x,l),e(x,Dt),e(x,B),e(B,Nt),e(x,Gt),c(t,Oe,l),c(t,H,l),e(H,R),e(R,ve),Ve(G,ve,null),e(H,Lt),e(H,ye),e(ye,qt),c(t,Ce,l),c(t,y,l),e(y,Wt),e(y,J),e(J,Mt),e(y,zt),e(y,j),e(j,Ft),e(y,Ut),c(t,De,l),c(t,b,l),e(b,Bt),e(b,be),e(be,Jt),e(b,jt),e(b,K),e(K,Kt),e(b,Qt),c(t,Ne,l),c(t,k,l),e(k,I),e(I,we),Ve(L,we,null),e(k,Vt),e(k,_e),e(_e,Xt),c(t,Ge,l),c(t,m,l),e(m,Yt),e(m,Ee),e(Ee,Zt),e(m,ea),e(m,Ae),e(Ae,ta),e(m,aa),e(m,Q),e(Q,oa),e(m,ia),c(t,Le,l),c(t,S,l),e(S,q),e(q,na),e(q,V),e(V,ra),e(q,sa),e(S,la),e(S,T),e(T,ha),e(T,He),e(He,ca),e(T,fa),e(T,ke),e(ke,da),e(T,pa),c(t,qe,l),c(t,w,l),e(w,ua),e(w,X),e(X,ga),e(w,ma),e(w,W),e(W,va),e(w,ya),We=!0},p:ho,i(t){We||(Xe(D.$$.fragment,t),Xe(N.$$.fragment,t),Xe(G.$$.fragment,t),Xe(L.$$.fragment,t),We=!0)},o(t){Ye(D.$$.fragment,t),Ye(N.$$.fragment,t),Ye(G.$$.fragment,t),Ye(L.$$.fragment,t),We=!1},d(t){a(_),t&&a(Te),t&&a(E),Ze(D),t&&a(Pe),t&&a(v),t&&a($e),t&&a(g),t&&a(xe),t&&a(A),Ze(N),t&&a(Re),t&&a(f),t&&a(Ie),t&&a(U),t&&a(Se),t&&a(x),t&&a(Oe),t&&a(H),Ze(G),t&&a(Ce),t&&a(y),t&&a(De),t&&a(b),t&&a(Ne),t&&a(k),Ze(L),t&&a(Ge),t&&a(m),t&&a(Le),t&&a(S),t&&a(qe),t&&a(w)}}}const po={local:"git-vs-http-paradigm",sections:[{local:"repository-the-historical-gitbased-approach",title:"Repository: the historical git-based approach"},{local:"hfapi-a-flexible-and-convenient-http-client",title:"HfApi: a flexible and convenient HTTP client"},{local:"what-should-i-use-and-when",title:"What should I use ? And when ?"}],title:"Git vs HTTP paradigm"};function uo(ba){return co(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class vo extends no{constructor(_){super();ro(this,_,uo,fo,so,{})}}export{vo as default,po as metadata};
